



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Uva 11077 Find the Permutations [置换群 DP]</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Uva 11077 Find the Permutations [置换群 DP]</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-06 16:16:33 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>题意：</p>
<p>给定$n$和$k$，问有多少排列交换$k$次能变成升序</p>
<p>$n \le 21$</p>
<hr />
<p>$uva$貌似挂掉了$vjudge$上一直排队</p>
<p>从某个排列到$1,2,...,n$和从$1,2,...,n$到某个排列是一样的</p>
<p>排列就是置换，分解循环，然后显然每个循环变成升序需要$len-1$次交换</p>
<p>然后有$t$个循环的置换需要$n-t$次交换</p>
<p>$DP$就行了$f[i][j]$表示前$i$个数有$j$个循环</p>
<p>其实可以发现就是<strong>第一类$stirling$数</strong></p>
<p><strong>注意：以后一定要测一遍极限会爆$long\ long$</strong></p>
<div>
<pre class="prettyprint linenums">#include&lt;iostream&gt;<br />
#include&lt;cstdio&gt;<br />
#include&lt;cstring&gt;<br />
#include&lt;algorithm&gt;<br />
#include&lt;cmath&gt;<br />
using namespace std;<br />
const int N=;<br />
typedef unsigned long long ll;<br />
inline int read(){<br />
    char c=getchar();int x=,f=;<br />
    while(c&lt;''||c&gt;''){if(c=='-')f=-; c=getchar();}<br />
    while(c&gt;=''&amp;&amp;c&lt;=''){x=x*+c-''; c=getchar();}<br />
    return x*f;<br />
}<br />
int n,k;<br />
ll f[N][N];<br />
void dp(){<br />
    f[][]=;<br />
    for(int i=;i&lt;=;i++)<br />
        for(int j=;j&lt;=;j++)<br />
            f[i][j]=f[i-][j-]+f[i-][j]*(i-);<br />
}<br />
int main(){<br />
    //freopen("in","r",stdin);<br />
    dp();<br />
    while(true){<br />
        n=read();k=read();<br />
        if(n==&amp;&amp;k==) break;<br />
        printf("%llu\n",f[n][n-k]);<br />
    }<br />
}</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/495glwzq.html">Spire&period;Pdf 的各种操作总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8eod3mq.html">goldengate for big data 12&period;3发布</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9pgj6y9.html">OpenSSLKey</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8erpjjq.html">直接拿来用！十大Material Design开源项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1ydm38.html">Eclipse 项目管理控制软件svn</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmwy109.html">poj 2262 Goldbach&amp;&num;39&semi;s Conjecture&lpar;素数筛选法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn140v38.html">expunge</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjyp379.html">OC - 2&period;OC基础知识介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x0p3n9.html">【leetcode系列】Valid Parentheses</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpp2o79.html">设计模式 - 出厂模式&lpar;factory pattern&rpar; 详细说明</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j2koo8.html">unity  collider 和 trigger  触发条件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljko309.html">String属于&OpenCurlyDoubleQuote;假引用类型&rdquo;，代码为证（一个String引发的血案&period;&period;&period;）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgmnxm8.html">BZOJ3529&colon; &lbrack;Sdoi2014&rsqb;数表</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rg3r578.html">我在微信小程序遇到的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zx4j59.html">题解 P1601 【A&plus;B Problem（高精）】</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv256dz9.html">运维架构之httpd</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25wvvoq.html">sqlserver2008简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2v61z9.html">S&sol;Kademlia2007 翻译</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2yrm9.html">java&period;lang&period;NumberFormatException&colon; Infinite or NaN</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4jroe0q.html">利用scp 远程上传下载文件&sol;文件夹</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qlj7nj19.html">java与C&plus;&plus;变量初始化的对比</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjx5x38.html">oracle分页查询及原理分析（总结）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1n03oq.html">setTimeout&lpar;&rpar;方法，你真的懂吗？</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgm0l48.html">C&plus;&plus; enum用法小技巧</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mezwnoq.html">Spark算子--flatMapValues</a>
			</li>
						<li><a href="https://www.batexi.com/a/950yw1m8.html">X-Windows桌面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp4vwj9.html">织梦DedeCMS&nbsp;v5&period;7&nbsp;实现导航条下拉菜单</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1xgd2q.html">WdatePicker设置时间区间时，对开始时间和结束时间限制</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojol61q.html">Lucene&period;net&lpar;4&period;8&period;0&rpar; 学习问题记录四&colon; IndexWriter 索引的优化以及思考</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj7xy69.html">HTTP常用方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
